angular.module('terralalune.controllers.account', [])

    .controller('LoginFormController', function (TerralaluneApp, CoveaAPI, $state, $ionicHistory, $ionicPopup, $localForage) {
                  this.data = {
                    mail: '',
                    password: ''
                  };
                 this.isSubmitting = false;

                  this.submit = function () {
                    if (this.isSubmitting) return;
                    this.isSubmitting = true;
                    CoveaAPI.api.user
                        .connection(this.data.mail, this.data.password)
                        .then(function (data) {
                                TerralaluneApp.userId = data.result.id;
                                TerralaluneApp.teamId = data.result.team_id;
                                TerralaluneApp.userEmail = data.result.mail;
                                $ionicHistory.nextViewOptions({disableBack: true});
                                                    this.isSubmitting = false;
                                                    $state.go('newGPSTrack');
                                                    $localForage.setItem('LoginFormController.data.mail', this.data.mail);
                              }.bind(this),
                              function (msg) {
                                $ionicPopup.alert({
                                                    title: 'Erreur',
                                                    template: msg.error,
                                                    okType: 'button-energized'
                                                  })
                                    .then(function() {
                                            this.isSubmitting = false;
                                          }.bind(this))

                              }.bind(this));
                  };

                  // -- let's go
                  $localForage
                      .getItem('LoginFormController.data.mail')
                      .then(function(item){
                              this.data.mail = item;
                            }.bind(this));

                })
    .controller('SignupFormController', function (CoveaAPI, $state, $ionicPopup) {
                  this.data = {
                    firstName: '',
                    lastName: '',
                    mail: '',
                    password: '',
                    passwordConfirm: ''
                  };
                  this.isSubmitting = false;

                  this.submit = function () {
                    this.isSubmitting = true;
                    CoveaAPI.api.user.set(this.data.firstName,
                                          this.data.lastName,
                                          this.data.mail,
                                          this.data.password)
                        .then(function () {
                                $ionicPopup
                                    .alert({
                                             title: 'Réussite',
                                             template: 'Création réussie. Vous allez recevoir un email.',
                                                                             okType: 'button-energized'
                                           })
                                    .then(function () {
                                            $state.go('login');
                                          });
                              },
                              function (msg) {
                                $ionicPopup.alert({
                                                    title: 'Erreur',
                                                    template: "Erreur de création d'utilisateur. Si vous avez déjà un compte, merci de passer par l'espace connexion.",
                                                    okType: 'button-energized'
                                                  });
                              })
                        .finally(function() {
                                   this.isSubmitting = false;
                                 }.bind(this));
                  }.bind(this);
                })
    .controller('ChangePasswordFormController', function (TerralaluneApp, CoveaAPI, $state, $ionicPopup) {
                  this.data = {
                    email: TerralaluneApp.userEmail,
                    oldPassword: '',
                    newPassword: ''
                  };
                  this.isSubmitting = false;

                  this.submit = function () {
                    this.isSubmitting = true;
                    CoveaAPI.api.user.changePassword(TerralaluneApp.userId,
                                                     this.data.oldPassword,
                                                     this.data.newPassword)
                        .then(function (data) {
                                $ionicPopup
                                    .alert({
                                             title: 'Réussite',
                                             template: 'Changement effectué. Vous allez être déconnecté.',
                                             okType: 'button-energized'
                                           })
                                    .then(function (res) {
                                            $state.go('logout');
                                          });
                              },
                              function (msg) {
                                $ionicPopup.alert({
                                                    title: 'Erreur',
                                                    template: msg.error,
                                                    okType: 'button-energized'
                                                  });
                              })
                        .finally(function() {
                                   this.isSubmitting = false;
                                 }.bind(this));
                  };
                })
    .controller('ResetPasswordFormController', function (TerralaluneApp, CoveaAPI, $state, $ionicPopup) {
                  this.data = {
                    mail: ''
                  };
                  this.isSubmitting = false;

                  this.submit = function () {
                    this.isSubmitting = true;
                    CoveaAPI.api.user.resetPassword(this.data.mail)
                        .then(function (data) {
                                $ionicPopup.alert({
                                                    title: 'Réussi',
                                                    template: 'Demande effectuée. Vous allez recevoir un email.',
                                                    okType: 'button-energized'
                                                  })
                                    .then(function (res) {
                                            $state.go('login');
                                          });
                              },
                              function (msg) {
                                $ionicPopup.alert({
                                                    title: 'Erreur',
                                                    template: msg.error,
                                                    okType: 'button-energized'
                                                  });
                              })
                        .finally(function() {
                                   this.isSubmitting = false;
                                 }.bind(this));
                  };
                })
    .controller('InviteColleagueFormController', function (TerralaluneApp, CoveaAPI, $state, $q, $ionicPopup) {
                  this.data = {
                    mail: ''
                  };
                  this.isSubmitting = false;

                  this.submit = function() {
                    this.isSubmitting = true;
                    CoveaAPI.api.user
                        .sendInvitation(TerralaluneApp.userId,
                                        this.data.mail)
                        .then(function(data) {
                                $ionicPopup.alert({
                                                    title: 'Succès',
                                                    template: 'Invitation envoyée',
                                                    okType: 'button-energized'
                                                  });
                                $state.reload();
                              }.bind(this),
                              function(msg) {
                                $ionicPopup.alert({
                                                    title: 'Erreur',
                                                    template: msg.error,
                                                    okType: 'button-energized'
                                                  });

                              })
                        .finally(function() {
                                   this.isSubmitting = false;
                                 }.bind(this));
                  };
                })
    .controller('StateLogoutController', function (TerralaluneApp, $state, $ionicHistory) {
                  TerralaluneApp.userId = 0;
                  TerralaluneApp.teamId = 0;
                  $ionicHistory.nextViewOptions({disableBack: true});
                  $state.go('login');
                })
    .controller('StateInviteColleagueController', function ($scope, nbInvitationsLeft) {
                  $scope.nbInvitationsLeft = nbInvitationsLeft;
                  $scope.canAddColleague = function () {
                    return $scope.nbInvitationsLeft > 0;
                  };

                });