angular.module('terralalune.controllers.general', [])

    .controller('TerralaluneController', function($rootScope, $state, TerralaluneApp, AuthRejectedCode, $ionicModal, $ionicPopup, PDFViewer) {

                  // -- handle auth reject
                  $rootScope.$on("$stateChangeError", function(event, toState, toParams, fromState, fromParams, error) {
                    if (error == AuthRejectedCode) {
                      $state.go('login');
                    }
                  });

                  this.isAuth = TerralaluneApp.isAuth;

                  // -- CGU Modale
                  this.openCGUModal = function() {
                    if (!this.CGUModal) {
                      return;
                    }
                    this.CGUModal.show();
                  }.bind(this)
                  ;
                  $ionicModal
                      .fromTemplateUrl('templates/general/cgu.html', {animation: 'slide-in-up'})
                      .then(function(modal) {
                              this.CGUModal = modal;
                              modal.scope.closeModal = function() {
                                modal.hide();
                              }.bind(this);
                              modal.scope.openUrl = this.openUrl;
                            }.bind(this));

                  this.logout = function() {
                    var confirmPopup = $ionicPopup.confirm({
                                                             title: 'Déconnexion',
                                                             template: 'Êtes-vous sûr de vouloir vous déconnecter ?',
                                                             cancelText: 'Non',
                                                             okText: 'Oui',
                                                             okType: 'button-energized'
                                                           });
                    confirmPopup.then(function(res) {
                      if (res) {
                        $state.go('logout');
                      }
                    });
                  };
                  this.sendEmail = function(email) {
                    window.open('mailto:' + email, '_system', 'location=yes');
                  };
                 this.openUrl = function(url) {
                   window.open(url, '_blank', 'location=yes');
                   return false;
                 };
                 this.openPdf = function(url){
                   PDFViewer.openPdf(url);
                 }
                })
    .controller('PageHomeController', function(CoveaAPI, $ionicPopup) {
                  this.totalDistance = 0;
                  this.distanceToGoal = 1;

                  CoveaAPI.api.distance.getStatsTotal()
                      .then(function(data) {
                              this.totalDistance = data.result.total;
                              this.distanceToGoal = data.result.distanceToGoal;
                            }.bind(this),
                            function(msg) {
                              //$ionicPopup.alert({
                              //                    title: 'Erreur',
                              //                    template: 'Erreur interne de l\'application',
                              //                    okType: 'button-energized'
                              //                  });
                            });
                })

    .controller('StateTeamPerformancesController', function($scope, teamData, teamRankingData, newMembresData, $ionicHistory) {
                  $ionicHistory.clearHistory();
                  $scope.teamData = teamData;
                  $scope.newMembresData = newMembresData;
                  $scope.teamsCount = teamRankingData.length;
                })
    .controller('StateMyPerformancesController', function($scope, performancesData, $ionicHistory) {
                  $ionicHistory.clearHistory();
                  $scope.performancesData = performancesData;
                });