angular.module('terralalune.controllers.track', [])
    .controller('GPSTrackFormController', function(TerralaluneApp, $scope, CoveaAPI, $ionicPopup, $state) {
                  this.data = {
                    type: 'foot',
                    gpsEnabled: false
                  };

                  this.submit = function() {
                    $state.go('GPSTrackInprogress',
                              {
                                type: this.data.type
                              });
                  }.bind(this);

                  this.viewActive = true;
                  $scope.$on('$ionicView.afterLeave', function() {
                    this.viewActive = false;
                  }.bind(this));
                  this.checkGPS = function() {
                    navigator.geolocation.getCurrentPosition(
                        function(position) {
                          this.data.gpsEnabled = true;
                          $scope.$apply();
                        }.bind(this),
                        function(msg) {
                          if (!this.viewActive) {
                            //console.debug('view no active anymore. do nothing.');
                            return;
                          }
                          this.data.gpsEnabled = false;
                          $ionicPopup.alert({
                                              title: 'Erreur',
                                              template: 'Impossible de déterminer la position. Avez-vous activé le GPS ?',
                                              okType: 'button-energized'
                                            }).
                              then(function() {
                                     this.checkGPS();
                                   }.bind(this));
                          $scope.$apply();
                        }.bind(this),
                        {timeout: 30000}
                    );
                  };

                  // -- let's go
                  this.checkGPS();
                })
    .controller('StateGPSTrackInprogressController', function($stateParams, $state, $ionicPopup, $scope, $localForage) {
                  this.trackData = {
                    type: $stateParams.type,
                    positions: [],
                    debugs: []
                  };
                  this.watchId = -1;
                  this.watchPositionErrors = [];
                  this.gpsEnabled = false;
                  this.lastGpsCall = false;

                  this.addPosition = function(position) {
                    //this.trackData.debugs.push(position);
                    if (position.coords.speed < 0) {
                      $scope.$apply();
                      return;
                    }
                    if (position.coords.accuracy > 30) {
                      $scope.$apply();
                      return;
                    }
                    this.trackData.positions.push(
                        [
                          position.coords.latitude,
                          position.coords.longitude
                        ]
                    );
                    $scope.polylineEncoded = polyline.encode(this.trackData.positions);
                    $scope.$apply();
                  }.bind(this);

                  this.beginWatchPosition = function() {
                    this.trackData.watchId =
                        navigator.geolocation.watchPosition(
                            function(position) {
                              this.gpsEnabled = true;
                              this.addPosition(position);
                            }.bind(this),
                            function(msg) {
                              this.gpsEnabled = false;
                              this.watchPositionErrors.push(msg);
                            }.bind(this),
                            {timeout: 30000, enableHighAccuracy: true, maximumAge: 3000}
                        );
                  }.bind(this);

                  this.stopTrack = function() {
                    navigator.geolocation.clearWatch(this.trackData.watchId);

                    var gotoFinishState = function() {
                      var polylineEncoded = polyline.encode(this.trackData.positions);
                      $localForage.setItem('polylineEncoded', polylineEncoded).then(function() {
                        $state.go('GPSTrackFinish', {
                          type: this.trackData.type
                        });
                      }.bind(this));
                    }.bind(this);

                    this.lastGpsCall = true;
                    navigator.geolocation.getCurrentPosition(
                        function(position) {
                          this.addPosition(position);
                          this.gpsEnabled = true;
                          gotoFinishState();
                        }.bind(this),
                        function(msg) {
                          this.gpsEnabled = false;
                          gotoFinishState();
                        }.bind(this),
                        {timeout: 30000});
                  }.bind(this);

                  // let's go
                  navigator.geolocation.getCurrentPosition(
                      function(position) {
                        this.gpsEnabled = true;
                        this.addPosition(position);
                        this.beginWatchPosition();
                      }.bind(this),
                      function(msg) {
                        this.gpsEnabled = false;
                        $ionicPopup
                            .alert({
                                     title: 'Erreur',
                                     template: 'Impossible de déterminer la position. Avez-vous activé le GPS ?',
                                     okType: 'button-energized'
                                   })
                            .then(function() {
                                    $state.go('newGPSTrack');
                                  });
                      }.bind(this),
                      {timeout: 30000}
                  );


                  this.getMapSrc = function() {
                    var polylineEncoded = polyline.encode(this.trackData.positions);
                    var pathParameters = [
                      'weight:3',
                      'color:red',
                      'enc:' + polylineEncoded
                    ];
                  }

                })
    .controller('StateGPSTrackFinishController', function($stateParams, TerralaluneApp, CoveaAPI, $state, $ionicPopup, UIHelperService, $scope, $localForage) {
                  this.trackData = {
                    type: $stateParams.type,
                    polylineEncoded: null
                  };
                  this.dataSentStatus = 'none';
                  this.distanceReceived = null;

                  this.sendTrack = function() {
                    UIHelperService.showLoading();
                    this.dataSentStatus = 'inprogress';
                    CoveaAPI.api.distance
                        .addByPosition(TerralaluneApp.userId,
                                       this.trackData.type,
                                       encodeURIComponent(this.trackData.polylineEncoded))
                        .then(function(res) {
                                this.distanceReceived = res['result'];
                                this.dataSentStatus = 'success';
                              }.bind(this),
                              function(msg) {
                                this.dataSentStatus = 'error';
                                $ionicPopup.alert(
                                    {
                                      title: 'Erreur',
                                      template: 'Erreur lors de l\'envoi des données',
                                      okType: 'button-energized'
                                    }
                                );
                              }.bind(this))
                        .finally(function() {
                                   UIHelperService.hideLoading();
                                 });
                  }.bind(this);

                  // let's go
                  $localForage.getItem('polylineEncoded')
                      .then(function(value) {
                              this.trackData.polylineEncoded = value;
                              // -- setup map preview
                              var pathParameters = [
                                'weight:3',
                                'color:red',
                                'enc:' + this.trackData.polylineEncoded
                              ];
                              $scope.polylineEncoded = this.trackData.polylineEncoded;

                              this.sendTrack();
                            }.bind(this));
                })
    .controller('GPSMapController', function($scope, $element, $timeout) {
                  $timeout(function() {

                    $scope.map = new google.maps.Map($element[0],
                                                     {
                                                       center: new google.maps.LatLng('0', '0'),
                                                       zoom: 15,
                                                       mapTypeId: google.maps.MapTypeId.ROADMAP,
                                                       disableDefaultUI: true
                                                     });

                    $scope.poly = new google.maps.Polyline({
                                                             strokeColor: '#82c4e3',
                                                             strokeOpacity: 1,
                                                             strokeWeight: 3,
                                                             map: $scope.map
                                                           });
                    $scope.$watch('polylineEncoded', function(value) {
                      if (typeof value == 'undefined') return;
                      var bounds = new google.maps.LatLngBounds();
                      var path = polyline.decode(value);
                      for (var i = 0; i < path.length; i++) {
                        path[i] = new google.maps.LatLng(path[i][0], path[i][1]);
                        bounds.extend(path[i]);
                      }
                      $scope.poly.setPath(path);
                      $scope.map.fitBounds(bounds);
                    });
                    $timeout(function() {
                      google.maps.event.trigger($scope.map, 'resize');
                    }, 1000)
                  }, 1000);

                })
    .controller('ManualTrackFormController', function(TerralaluneApp, CoveaAPI, $state, $ionicPopup) {
                  this.data = {
                    total: '',
                    type: 'foot'
                  };
                  this.isSubmitting = false;
                  this.submit = function() {
                    this.isSubmitting = true;
                    CoveaAPI.api.distance.addManual(TerralaluneApp.userId,
                                                    this.data.type,
                                                    this.data.total * 1000)
                        .then(function(data) {
                                $ionicPopup
                                    .alert({
                                             title: 'Réussite',
                                             template: 'Vous avez contribué de ' + this.data.total + ' kilomètres au challenge.',
                                             okType: 'button-energized'
                                           })
                                    .then(function(res) {
                                            $state.go('myPerformances');
                                          });
                              }.bind(this),
                              function(msg) {
                                $ionicPopup.alert({
                                                    title: 'Erreur',
                                                    template: msg.error,
                                                    okType: 'button-energized'
                                                  });
                              })
                        .finally(function() {
                                   this.isSubmitting = false;
                                 }.bind(this));
                  };
                });
