angular.module('terralalune.directives', [])
    .directive('overwriteEmail', function () {
                 var allowedDomains = [
                   'groupe-mma.fr',
                   'ladas.fr',
                   'covea-caution.fr',
                   'covea-fleet.fr',
                   'lybernet.fr',
                   'covea-risk.fr',
                   'covea.fr',
                   'mma.fr',
                   'maaf.fr',
                   'nexx.fr',
                   'coveafinance.fr',
                   'gmf.fr',
                   'covea-immobilier.fr',
                   'covea-finance.fr',
                   'lapj.fr',
                   'fidelia-assistance.fr',
                   'kernix.com',
                   'hop-cube.com',
                   'abpiard.fr',
                   'covea-affinity.com',
                   'covea-risks.fr'
                 ];
                 var EMAIL_REGEXP = new RegExp("^[a-z0-9!#$%&'*+/=?^_`{|}~.-]+@("+allowedDomains.join('|')+")$", 'i');

                 return {
                   require: 'ngModel',
                   restrict: '',
                   link: function (scope, elm, attrs, ctrl) {
                     // only apply the validator if ngModel is present and Angular has added the email validator
                     if (ctrl && ctrl.$validators.email) {

                       // this will overwrite the default Angular email validator
                       ctrl.$validators.email = function (modelValue) {
                         return ctrl.$isEmpty(modelValue) || EMAIL_REGEXP.test(modelValue);
                       };
                     }
                   }
                 };
               })
    .directive('nxEqual', function() {
    return {
        	require: 'ngModel',
        	link: function (scope, elem, attrs, model) {
            	if (!attrs.nxEqual) {
                	console.error('nxEqual expects a model as an argument!');
                	return;
            		}
            		scope.$watch(attrs.nxEqual, function (value) {
                	// Only compare values if the second ctrl has a value.
                	if (model.$viewValue !== undefined && model.$viewValue !== '') {
                    	model.$setValidity('nxEqual', value === model.$viewValue);
                	}
            	});
            	model.$parsers.push(function (value) {
                // Mute the nxEqual error if the second ctrl is empty.
            		if (value === undefined || value === '') {
            			model.$setValidity('nxEqual', true);
            			return value;
            		}
                var isValid = value === scope.$eval(attrs.nxEqual);
                model.$setValidity('nxEqual', isValid);
                return isValid ? value : undefined;
            	});
        	}
    	};
    })
	.directive('checkRequired', function(){
	  return {
	    require: 'ngModel',
	    restrict: 'A',
	    link: function (scope, element, attrs, ngModel) {
	      ngModel.$validators.checkRequired = function (modelValue, viewValue) {
	        var value = modelValue || viewValue;
	        var match = scope.$eval(attrs.ngTrueValue) || true;
	        return value && match === value;
	      };
	    }
	  }; 
	})
	
	
;

