angular.module('terralalune.filters', [])
    .filter('formatNumber', function () {
		return function (value, decimalsCount) {
      decimalsCount = decimalsCount || 0;
      if (isNaN(value)) return 0;


      var decimals = 0;
      if (decimalsCount > 0){
        value = Math.round(value * Math.pow(10, decimalsCount)) / Math.pow(10, decimalsCount);
        decimals = value * Math.pow(10, decimalsCount);
        decimals = Math.floor(decimals);
        decimals = decimals % Math.pow(10, decimalsCount);
      }
      else{
        value = Math.round(value);
      }

      value = Math.floor(value);
      var underThousands = Math.floor(value % 1000);
      var thousands = Math.floor(value / 1000);

      var pad = function (n, width, z) {
        z = z || '0';
        n = n + '';
        return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
      };

      var formattedString;
      if (thousands > 0) {
        formattedString = thousands + ' ' + pad(underThousands, 3);
      }
      else {
        formattedString = underThousands;
      }
      if (decimals > 0) {
        formattedString += ',' + pad(decimals, decimalsCount);
      }
      return formattedString;
    };
	});