angular.module('terralalune.services', [])

    .factory('CoveaAPI', function ($http, $q) {

               var protocole = 'https://';
               var serverUrl = 'www.challenge-covea-terre-lune.fr';
               //var protocole = 'http://';
               //var serverUrl = 'covea.hogwarts.hop-cube.com';
               var apiUrl = '/api';
               var privateKey = 'GKPD305ksy';
               var APIKey = '3495854';

               var service = {};

               service.hashSha1 = function (msg) {
                 var shaObj = new jsSHA("SHA-1", "TEXT");
                 shaObj.setHMACKey(privateKey, 'TEXT');
                 shaObj.update(msg);
                 return shaObj.getHMAC('HEX');
               };

               service.getAuthentifiedUrl = function (module, method, parameters) {

                 // -- build URL
                 parameters = parameters || {};
                 parameters['apikey'] = APIKey;
                 var paramsString = '';
                 for (var paramName in parameters) {
                   if (!parameters.hasOwnProperty(paramName)) {
                     continue;
                   }
                   var paramValue = parameters[paramName];
                   paramsString += '/' + paramName + '/' + paramValue;
                 }
                 var baseUrl = apiUrl + '/' + module + '/' + method + '' + paramsString;
                 //console.log(baseUrl);

                 // -- encode URL
                 var password = service.hashSha1(baseUrl);

                 return {
                   authUrl: baseUrl + '/password/' + password,
                   password: password
                 };
               };

               service.call = function (module, method, parameters, postParameters) {
                 var deferred = $q.defer();
                 if (typeof postParameters != 'undefined') {
                   $http.post(protocole + serverUrl + service.getAuthentifiedUrl(module, method, parameters).authUrl,
                              postParameters,
                              {
                                headers: {
                                  'Content-Type': 'application/x-www-form-urlencoded'
                                }
                              })
                       .success(function(data) {
                                  deferred.resolve(data);
                                })
                       .error(function(msg) {
                                deferred.reject(msg);
                              });
                 }
                 else {
                   $http.get(protocole + serverUrl + service.getAuthentifiedUrl(module, method, parameters).authUrl)
                       .success(function(data) {
                                  deferred.resolve(data);
                                })
                       .error(function(msg) {
                                deferred.reject(msg);
                              });
                 }
                 return deferred.promise;
               };

               service.api = {
                 testHmap: function () {
                   //var testURL = 'user/set/name/hugues/lastName/michel/mail/hmichel@kernix.com/userPassword/kernix/apikey/3495854';
                   var authUrl = service.getAuthentifiedUrl('user', 'set', {
                     name: 'hugues',
                     lastname: 'michel',
                     mail: 'hmichel@kernix.com',
                     userpassword: 'kernix'
                   });
                   var resultExpected = 'f00634bda6d704e7a7bce3ce71d53722155281a5';
                   return {
                     authURL: authUrl,
                     resultExpected: resultExpected,
                     isOK: resultExpected == authUrl.password
                   };
                 },
                 user: {
                   set: function (name, lastName, mail, userPassword) {
                     return service.call('user',
                                         'set',
                                         {
                                           name: name,
                                           lastname: lastName,
                                           mail: mail,
                                           userpassword: service.hashSha1(userPassword)
                                         });
                   },
                   connection: function (mail, userPassword) {
                     return service.call('user',
                                         'connection',
                                         {
                                           mail: mail,
                                           userpassword: service.hashSha1(userPassword)
                                         });
                   },
                   get: function (id) {
                     return service.call('user',
                                         'get',
                                         {
                                           id: id
                                         });
                   },
                   nbInvitationsLeft: function (user) {
                     return service.call('user',
                                         'nbInvitationsLeft',
                                         {
                                           user: user
                                         });
                   },
                   sendInvitation: function (user, mail) {
                     return service.call('user',
                                         'sendInvitation',
                                         {
                                           user: user,
                                           mail: mail
                                         });
                   },
                   resetPassword: function (mail) {
                     return service.call('user',
                                         'resetPassword',
                                         {
                                           mail: mail
                                         });
                   },
                   changePassword: function (id, oldPassword, newPassword) {
                     return service.call('user',
                                         'changePassword',
                                         {
                                           id: id,
                                           oldpassword: service.hashSha1(oldPassword),
                                           newpassword: service.hashSha1(newPassword)
                                         });
                   },
                   getTotalUsers: function () {
                     return service.call('user',
                                         'getTotalUsers',
                                         {});
                   },
                   getPercentUsersOfCompany: function () {
                     return service.call('user',
                                         'getPercentUsersOfCompany',
                                         {});
                   }
                 },
                 team: {
                   get: function (teamId) {
                     return service.call('team',
                                         'get',
                                         {id: teamId});
                   },
                   getRanking: function () {
                     return service.call('team',
                                         'getRanking',
                                         {});
                   },
                   getNewUsers: function (teamId) {
                     return service.call('team',
                                         'getNewUsers',
                                         {id: teamId});
                   }
                 },
                 distance: {
                   addByPosition: function (id, type, polylineEncoded) {
                     return service.call('distance',
                                         'addByPosition/p',
                                         {
                                           id: id,
                                           type: type
                                         },
                                         'step='+polylineEncoded
                     );
                   },
                   addManual: function (id, type, total) {
                     return service.call('distance',
                                         'addManual',
                                         {
                                           id: id,
                                           type: type,
                                           total: total
                                         });
                   },
                   getStatsTotal: function () {
                     return service.call('distance',
                                         'getStatsTotal',
                                         {});
                   }
                 }
               };


               return service;

             }).
    factory('TerralaluneApp', function () {
              var service = {};

              service.userId = 0;
              service.teamId = 0;
              service.userEmail = '';

              service.isAuth = function () {
                return service.userId > 0;
              };
              return service;
            })
    .factory('UIHelperService', function($ionicLoading) {
               var service = {};
               service.showLoading = function() {
                 $ionicLoading.show({
                                      template: '<div class="spinner">' +
                                      '<div class="bounce1"></div>' +
                                      '<div class="bounce2"></div>' +
                                      '<div class="bounce3"></div>' +
                                      '</div>'
                                    });
               };
               service.hideLoading = function() {
                 $ionicLoading.hide();
               };

               return service;
             })



    .factory('DeviceService', function ($rootScope) {
               var service = {
                 networkStatus: {
                   isConnected: false
                 }
               };

               service.init = function () {
                 document.addEventListener("offline", service.onOffline, false);
                 document.addEventListener("online", service.onOnline, false);
                 service.networkStatus.isConnected = !(navigator.connection && navigator.connection.type == Connection.NONE);
               };
               service.onOffline = function () {
                 service.networkStatus.isConnected = false;
                 $rootScope.$apply();
               };
               service.onOnline = function () {
                 service.networkStatus.isConnected = true;
                 $rootScope.$apply();
               };
               service.getNetworkStatus = function () {
                 return service.networkStatus;
               };
               $rootScope.getNetworkStatus = function () {
                 return service.getNetworkStatus();
               };

               return service;
             })
    .factory('PDFViewer', function(){
              return {
                  openPdf: function(pdfFileName) {

                    function getWorkingFolderURL() {
                      var indexUrl = window.location.href;
                      return indexUrl.substring(0, indexUrl.indexOf("index.html"));
                    }

                    function getWorkingFolderFileURL(filePath) {
                      return getWorkingFolderURL().replace("http://", "file://") + filePath;
                    }

                    function loadPdf(targetUrl) {
                      var windowTarget = device.platform.toLowerCase() === "ios" ? "_blank" : "_system";
                      window.open(targetUrl, windowTarget, "location=yes,hidden=no");
                    }

                    function loadPdfFromFileEntry(fileEntry) {
                      loadPdf(fileEntry.toURL());
                    }

                    function copyFile(sourceUri, targetUri, successFunction, errorFunction) {
                      var fileTransfer = new FileTransfer();
                      fileTransfer.download(
                          encodeURI(sourceUri),
                          encodeURI(targetUri),
                          successFunction,
                          errorFunction);
                    }

                    var samplePdfUrl;

                    if (window.navigator.simulator === true) {
                      alert("download pdf not available in Simulator.");
                    }
                    else {
                      if (device.platform.toLowerCase() === "android") {
                        // file:///storage/emulated/0/Android/data/<app-id>/files/
                        // Directory has to be public, for the default pdf viewer to read it.
                        samplePdfUrl = cordova.file.externalDataDirectory + pdfFileName;

                        // Check whether the sample PDF file exists.
                        window.resolveLocalFileSystemURL(
                            samplePdfUrl,
                            loadPdfFromFileEntry,
                            function(error) {
                              copyFile(
                                  getWorkingFolderFileURL(pdfFileName),
                                  samplePdfUrl,
                                  loadPdfFromFileEntry,
                                  function(error) {
                                    alert("Error copying file.");
                                    //console.log("Error: " + JSON.stringify(error, null, 4));
                                  });
                            });
                      }
                      else {
                        samplePdfUrl = getWorkingFolderFileURL(pdfFileName);
                        loadPdf(samplePdfUrl);
                      }
                    }
                  }
                  };
             });